package com.sensorsystem1.bluetooth;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Date;
import java.util.Set;
import java.util.UUID;

import com.Global;
import com.jjoe64.graphview.series.DataPoint;
import com.sensorsystem1.MainActivity;
import com.sensorsystem1.R;
import com.sensorsystem1.history.DataView;
import com.sensorsystem1.save.save;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class SerialBlue extends Activity {
	// TextView myLabel;
	// EditText myTextbox;
	BluetoothAdapter mBluetoothAdapter;
	BluetoothSocket mmSocket;
	BluetoothDevice mmDevice;
	OutputStream mmOutputStream;
	InputStream mmInputStream;
	Thread workerThread;
	byte[] readBuffer;
	int readBufferPosition;
	int counter;
	volatile boolean stopWorker;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.bluetoothserial);

		try {
			findBT();
			openBT();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.simple, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// openContextMenu(lv);
		Intent intent;
		switch (item.getItemId()) {
		case R.id.main:
			intent = new Intent(this, MainActivity.class);
			startActivity(intent);
			break;
		}
		return super.onOptionsItemSelected(item);
	}

	void findBT() {
		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		if (mBluetoothAdapter == null) {
			// myLabel.setText("No bluetooth adapter available");
		}

		if (!mBluetoothAdapter.isEnabled()) {
			Intent enableBluetooth = new Intent(
					BluetoothAdapter.ACTION_REQUEST_ENABLE);
			startActivityForResult(enableBluetooth, 0);
		}

		Set<BluetoothDevice> pairedDevices = mBluetoothAdapter
				.getBondedDevices();
		if (pairedDevices.size() > 0) {
			for (BluetoothDevice device : pairedDevices) {
				if (device.getName().equals("George")) {
					mmDevice = device;
					break;
				}
			}
		}
		// myLabel.setText("Bluetooth Device Found");
	}

	void openBT() throws IOException {
		UUID uuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB"); // Standard
																				// SerialPortService
		System.out.println("TEsting111111111111"); // ID
		mmSocket = mmDevice.createRfcommSocketToServiceRecord(uuid);
		mmSocket.connect();
		mmOutputStream = mmSocket.getOutputStream();
		mmInputStream = mmSocket.getInputStream();
		System.out.println("TEsting111111111111");
		beginListenForData();

		// myLabel.setText("Bluetooth Opened");
	}

	void beginListenForData() {
		final Handler handler = new Handler();
		final byte delimiter = 10; // This is the ASCII code for a newline
									// character

		stopWorker = false;
		readBufferPosition = 0;
		readBuffer = new byte[1024];
		workerThread = new Thread(new Runnable() {
			public void run() {
				while (!Thread.currentThread().isInterrupted() && !stopWorker) {
					try {
						// System.out.println("TEsting");
						int bytesAvailable = mmInputStream.available();
						if (bytesAvailable > 0) {
							byte[] packetBytes = new byte[bytesAvailable];
							mmInputStream.read(packetBytes);
							for (int i = 0; i < bytesAvailable; i++) {
								byte b = packetBytes[i];
								if (b == delimiter) {
									byte[] encodedBytes = new byte[readBufferPosition];
									System.arraycopy(readBuffer, 0,
											encodedBytes, 0,
											encodedBytes.length);
									final String data = new String(
											encodedBytes, "US-ASCII");
									readBufferPosition = 0;

									handler.post(new Runnable() {
										/*
										 * 
										 * 
										 * 
										 * 
										 * 
										 * 
										 * (non-Javadoc)
										 * 
										 * @see java.lang.Runnable#run()
										 */
										public void run() {
											System.out.println("TEst" + data);
											resondToSignal(data);
											// myLabel.setText(data);
										}
									});
								} else {
									readBuffer[readBufferPosition++] = b;
								}
							}
						}
					} catch (IOException ex) {
						stopWorker = true;
					}
				}
			}
		});

		workerThread.start();
	}

	void resondToSignal(String temp) {
		try {
			closeBT();
			// DataPoint dp = new DataPoint(new Date(),
			// Double.parseDouble(temp));
			// ((Global) this.getApplication()).addDataPoint(dp);
			System.out.println(temp + " TESTING YO HO HO");
			String[] datasplit = temp.split(" ");

			DataPoint[] dp = {
					new DataPoint(new Date(), Double.parseDouble(datasplit[0])),
					new DataPoint(new Date(), Double.parseDouble(datasplit[1])) };
			((Global) this.getApplication()).addDataPoint(dp);

			
			save saveStuff = new save();
			saveStuff
					.SaveData(((Global) this.getApplication()).getDatapoints());
			
//			sendData();

			Intent intent1 = new Intent(this, DataView.class);
			startActivity(intent1);
		} catch (IOException e) {
		e.printStackTrace();
			System.out.println(e + "BLUETOOTH ERROR");

		}
	}

	// void sendData() throws IOException {
	// // String msg = myTextbox.getText().toString();
	// // msg += "\n";s
	// // mmOutputStream.write(msg.getBytes());
	// // myLabel.setText("Data Sent");
	// }

	void closeBT() throws IOException {
		stopWorker = true;
		mmOutputStream.close();
		mmInputStream.close();
		mmSocket.close();
		// myLabel.setText("Bluetooth Closed");
	}
	
	void sendData() throws IOException {
		String msg = "OK\n";
		mmOutputStream.write(msg.getBytes());
	}
}