package com.sensorsystem1.graph;

import java.util.Date;
import java.util.Vector;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;

import com.Global;
import com.jjoe64.graphview.DefaultLabelFormatter;
import com.jjoe64.graphview.GraphView;
import com.jjoe64.graphview.LabelFormatter;
import com.jjoe64.graphview.LegendRenderer;
import com.jjoe64.graphview.helper.DateAsXAxisLabelFormatter;
import com.jjoe64.graphview.series.DataPoint;
import com.jjoe64.graphview.series.LineGraphSeries;
import com.sensorsystem1.MainActivity;
import com.sensorsystem1.R;

public class Graph extends Activity {

	ListView lv;
	int days = 0;

	GraphView graph;
	boolean firstTime = true;

	String graphType = "temp";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// sEtContentView(R.layout.popup_menu);

		super.onCreate(savedInstanceState);
		setContentView(R.layout.graph);
		graph = (GraphView) findViewById(R.id.graph);
		// graph.getLegendRenderer().setVisible(true);
		// graph.getLegendRenderer().setAlign(LegendRenderer.LegendAlign.TOP);
		displayGraph();
		// graph.getGridLabelRenderer().setNumHorizontalLabels(3); // only 4
		// because of the space

		final Button temp_button = (Button) findViewById(R.id.temp_but);
		temp_button.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				graphType = "temp";
				displayGraph();
			}
		});

		final Button light_button = (Button) findViewById(R.id.light_but);
		light_button.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				graphType = "light";
				displayGraph();
			}
		});

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.graph, menu);
		return true;
	}

	// public void onCreateContextMenu(ContextMenu menu, View v,
	// ContextMenuInfo menuInfo) {
	// System.out.println("YO HO HO");
	// // Inflate the menu; this adds items to the action bar if it is present.
	// getMenuInflater().inflate(R.menu.graph_pop, menu);
	// }

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// openContextMenu(lv);
		switch (item.getItemId()) {
		case R.id.main:
			Intent intent = new Intent(this, MainActivity.class);
			startActivity(intent);
			break;
		case R.id.one_day:
			days = 1;
			displayGraph();
			break;
		case R.id.seven_day:
			days = 7;
			displayGraph();
			break;
		case R.id.month:
			days = 30;
			displayGraph();
			break;
		case R.id.all_time:
			days = 0;
			displayGraph();
			break;
		}
		return super.onOptionsItemSelected(item);
	}

	public void displayGraph() {
		Vector<LineGraphSeries<DataPoint>> seriesVec = ((Global) this
				.getApplication()).getSeriesBackWard();
		graph.removeAllSeries();
		graph.getLegendRenderer().resetStyles();
		try {
			if (days > 0) {
				seriesVec = ((Global) this.getApplication())
						.getSeriesBackWard(days);
			} else {

			}
			graph = (GraphView) findViewById(R.id.graph);
			if (days != 1) {
				graph.getGridLabelRenderer().setLabelFormatter(
						(LabelFormatter) new DateAsXAxisLabelFormatter(this));
				graph.getGridLabelRenderer().setHorizontalAxisTitle("Date");
			} else {
				graph.getGridLabelRenderer().setHorizontalAxisTitle("Hour");
				graph.getGridLabelRenderer().setLabelFormatter(
						new DefaultLabelFormatter() {
							@Override
							public String formatLabel(double value,
									boolean isValueX) {
								if (isValueX) {
									// show normal x values
									Date dt = new Date();  // current time
									dt.setTime((long)value);
									
									return super.formatLabel(dt.getHours(), isValueX);
								} else {
									// show currency for y values
									return super.formatLabel(value, isValueX);
								}
							}
						});

			}

			if (graphType.equals("temp")) {
				seriesVec.get(0);
				graph.addSeries(seriesVec.get(0));
				// seriesVec.get(0).setTitle("Temperature (degrees celius)");
				graph.getGridLabelRenderer().setVerticalAxisTitle(
						"Temperature (degrees celius)");
				graph.setTitle("Temperature VS Date");
			} else if (graphType.equals("light")) {
				graph.addSeries(seriesVec.get(1));
				graph.setTitle("Light VS Date");
				// seriesVec.get(1).setTitle("Light");
				graph.getGridLabelRenderer().setVerticalAxisTitle("Light");
			}
			// graph.getSecondScale().addSeries(seriesVec.get(0));
			// graph.getSecondScale().setMinY(0);
			// graph.getSecondScale().setMaxY(40);

			seriesVec.get(1).setColor(Color.RED);
			seriesVec.get(0).setColor(Color.BLUE);
			// if (firstTime == true) {

			// firstTime=false;
			// }

			// set date label formatter

			// graph.getGridLabelRenderer().setVerticalLabelsSecondScaleColor(
			// Color.RED);
			// graph.getGridLabelRenderer().se
		} catch (Exception e) {
			e.printStackTrace();
			// System.out.println(e. + " YO HO HO HOHO HO HOH O");
			graph.removeAllSeries();
		}

	}
	// public void showPopup() {
	// //// System.out.println("YO HO HO");
	// // PopupMenu popup = new PopupMenu(this, findViewById(R.menu.graph_pop));
	// // MenuInflater inflater = popup.getMenuInflater();
	// // inflater.inflate(R.menu.graph_pop, popup.getMenu());
	// // popup.show();
	// getMenuInflater().inflate(R.menu.graph_pop, R.layout.popup_menu);
	// }

}
