package com.sensorsystem1.nfc;

import java.util.Date;

import android.app.Activity;
import android.app.PendingIntent;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.IntentFilter.MalformedMimeTypeException;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.NfcF;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;

import com.Global;
import com.jjoe64.graphview.series.DataPoint;
import com.sensorsystem1.MainActivity;
import com.sensorsystem1.R;
import com.sensorsystem1.history.DataView;
import com.sensorsystem1.save.save;

public class Reading extends Activity {

	IntentFilter[] intentFiltersArray;
	String[][] techListsArray;
	PendingIntent pendingIntent;
	NfcAdapter mAdapter;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.nfc);

		pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this,
				getClass()).addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP), 0);
		IntentFilter ndef = new IntentFilter(NfcAdapter.ACTION_NDEF_DISCOVERED);
		try {
			ndef.addDataType("text/plain"); /*
											 * Handles all MIME based
											 * dispatches. You should specify
											 * only the ones that you need.
											 */
		} catch (MalformedMimeTypeException e) {
			throw new RuntimeException("fail", e);
		}
		intentFiltersArray = new IntentFilter[] { ndef, };

		techListsArray = new String[][] { new String[] { NfcF.class.getName() } };

		mAdapter = NfcAdapter.getDefaultAdapter(this);
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.simple, menu);
		return true;
	}
	

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// openContextMenu(lv);
		Intent intent;
		switch (item.getItemId()) {
		case R.id.main:
			intent = new Intent(this, MainActivity.class);
			startActivity(intent);
			break;
		}
		return super.onOptionsItemSelected(item);
	}

	@Override
	public void onPause() {
		super.onPause();
		mAdapter.disableForegroundDispatch(this);
		System.out.println("Pause");
	}

	@Override
	public void onResume() {
		super.onResume();
		mAdapter.enableForegroundDispatch(this, pendingIntent,
				intentFiltersArray, techListsArray);
		System.out.println("Resueme");
		save saveStuff = new save();
		saveStuff.SaveData(((Global) this.getApplication()).getDatapoints());
	}

	public void onNewIntent(Intent intent) {
		Tag tagFromIntent = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
		NFC nfc = new NFC();
		try {
			String data = nfc.readTag(tagFromIntent);
			System.out.println(nfc.readTag(tagFromIntent) + " TESTING YO HO HO");
			String[] datasplit = data.split(" ");

			DataPoint[] dp = {new DataPoint(new Date(), Double.parseDouble(datasplit[0])),new DataPoint(new Date(), Double.parseDouble(datasplit[1])) };
			((Global) this.getApplication()).addDataPoint(dp);

			Intent intent1 = new Intent(this, DataView.class);
			startActivity(intent1);
		} catch (NullPointerException e) {
			e.printStackTrace();

		}
		// do something with tagFromIntent
		
	}
	

}
